package bc_permission;

use bc_packetint;

use strict;

sub get_rank {
  my $playerID = $_[0];
  my $ret;

  if (is_sysop($playerID)) {
    $ret = 0;
  }
  elsif (is_mod($playerID)) {
    $ret = 1;
  }
  else {
    $ret = 2;
  }
}

sub is_sysop {
  my $playerID = $_[0];
  my ($fileLoc, $ret, $name, $gname);

  $ret = 0;
  $fileLoc = "./etc/botsysop.txt";
  open(FD, $fileLoc);
  while (<FD>) {
    chomp;
    $name = lc($_);
    $gname = unpack("Z*", lc($bc_packetint::p[$playerID]{'name'}));
    
    if ($name eq $gname) {
      $ret = 1;
    }
  }
  close(FD);
  return $ret;
}

sub is_sysopN {
  my $playerName = $_[0];
  my ($fileLoc, $ret, $name, $gname);

  $ret = 0;
  $fileLoc = "./etc/botsysop.txt";
  open(FD, $fileLoc);
  while (<FD>) {
    chomp;
    $name = lc($_);
    $gname = unpack("Z*", lc($playerName));

    if ($name eq $gname) {
      $ret = 1;
    }
  }
  close(FD);
  return $ret;
}

sub is_mod {
  my $playerID = $_[0];
  my ($fileLoc, $ret, $name, $gname);

  $ret = 0;
  $fileLoc = "./etc/botmod.txt";
  open(FD, $fileLoc);
  while (<FD>) {
    chomp;
    $name = lc($_);
    $gname = unpack("Z*", lc($bc_packetint::p[$playerID]{'name'}));

    if ($name eq $gname) {
      $ret = 1;
    }
  }
  close(FD);
  return $ret;
}

sub is_modN {
  my $playerName = $_[0];
  my ($fileLoc, $ret, $name, $gname);

  $ret = 0;
  $fileLoc = "./etc/botmod.txt";
  open(FD, $fileLoc);
  while (<FD>) {
    chomp;
    $name = lc($_);
    $gname = unpack("Z*", lc($playerName));

    if ($name eq $gname) {
      $ret = 1;
    }
  }
  close(FD);
  return $ret;
}

sub add_sysop {
  my $playerName = $_[0];
  my $fileLoc;

  if (is_sysopN($playerName)) {
    return 0;
  } else {
    $fileLoc = "./etc/botsysop.txt";
    open(FD, ">>$fileLoc");
    print FD $playerName;
    close(FD);
    return 1;
  }
}

sub remove_sysop {
  my $playerName = $_[0];
  my (@names, $fileLoc);

  $fileLoc = "./etc/botsysop.txt";
  if (!is_sysopN($playerName)) {
    return 0;
  } else {
    open(FD, $fileLoc);
    while (<FD>) {
      if (lc($_) ne lc($playerName)) {
	$names[$.-1] = $_;
      }
    }
    close(FD);
    open(FD, ">$fileLoc");
    foreach (@names) {
      print FD $_;
    }
    close(FD);
  }
}

sub add_mod {
  my $playerName = $_[0];
  my $fileLoc;

  if (is_modN($playerName)) {
    return 0;
  } else {
    $fileLoc = "./etc/botmod.txt";
    open(FD, ">>$fileLoc");
    print FD $playerName;
    close(FD);
    return 1;
  }
}

sub remove_mod {
  my $playerName = $_[0];
  my (@names, $fileLoc);

  $fileLoc = "./etc/botmod.txt";
  if (!is_modN($playerName)) {
    return 0;
  } else {
    open(FD, $fileLoc);
    while (<FD>) {
      if (lc($_) ne lc($playerName)) {
	$names[$.-1] = $_;
      }
    }
    close(FD);
    open(FD, ">$fileLoc");
    foreach (@names) {
      print FD $_;
    }
    close(FD);
  }
}

# Signal EOF
1;
